#include <stdlib.h>
#include "pset.h"

int main(int argc, char **argv)
{
	BENCH_PARAM *para;
	ERR_MEASURE *err_measure;

	para = (BENCH_PARAM *) malloc (sizeof(BENCH_PARAM));
	err_measure = (ERR_MEASURE *) malloc (sizeof(ERR_MEASURE));

	para->htol = 90;
	para->vtol = 80;
	para->hpix = 11;
	para->vpix = 8;

	/* argv[1] pointer to a string that stores input image file name */
	/* argv[2] pointer to a string that stores groundtruth file name */
	/* argv[3] pointer to a string that stores segmentation result file name */

	Bench(argv[1], para, argv[2], argv[3], &err_measure);

	printf("nSplLine = %d\tnMrgLine = %d\tnMisLine = %d\tnErrLine = %d\tnGtLine = %d\n",
		err_measure->nSplLine,
		err_measure->nMrgLine,
		err_measure->nMisLine,
		err_measure->nErrLine,
		err_measure->nGtLine);
		 
	free(para);
	free(err_measure);

	return(0);
}
