/* 
**  File: FreeJobTest.c
**  Purpose: free previously allocated memory
**  Author: Song Mao (maosong@cfar.umd.edu)
**  Date:   22 March 1999
**  Organization: Language and Media Processing Lab
**                 Center for Automation Research
**                   University of Maryland
**                   College Park, MD 20742
**  $Id: FreeJobTest.c,v 1.1 2000/09/19 22:16:27 maosong Exp $
*/

#include <stdlib.h>
#include <stdio.h>

#include "pset.h"

void FreeJobTest(TEST_PROTOCOL *test_protocol, char *test_report,
		 char *test_protocol_file, void *ben_param, void *seg_param,
		 char *seg_file, char *ben_file, char *weight_file)
{
	int i;

	switch(test_protocol->seg_alg) {
		case XYCUT:
			free(((XYCUT_PARAM *)(seg_param)));
			break;
		case DOCSTRUM:
			free(((DOCSTRUM_PARAM *)(seg_param))->concom_dir);
			free(((DOCSTRUM_PARAM *)(seg_param))->concom_suffix);
			free(((DOCSTRUM_PARAM *)(seg_param)));
			break;
		case VORONOI:
			free(((VORONOI_PARAM *)(seg_param)));
			break;
		default:
			break;
	}

        switch(test_protocol->ben_alg) {
                case TEXTLINE_BASED:
			free(((BENCH_PARAM *)(ben_param)));
			break;
                default:
                        break;
        }

	for(i = 0; i < test_protocol->dataset->nImg; i++)
                free(test_protocol->dataset->ImgName[i]);
        free(test_protocol->dataset->ImgName);
	free(test_protocol->dataset);
	free(test_protocol->gt_dir);
	free(test_protocol->img_dir);
	free(test_protocol->gt_suffix);
	free(test_protocol->sg_suffix);
	free(test_protocol->img_suffix);
	free(test_protocol->test_result_dir);

	free(test_protocol);
	free(test_report);
	free(test_protocol_file);
	free(seg_file);
	free(ben_file);
	free(weight_file);
}
