/* 
**  File: ParseArgTest.c
**  Purpose: parsing the command line argument
**  Author: Song Mao (maosong@cfar.umd.edu)
**  Date:   22 March 1999
**  Organization: Language and Media Processing Lab
**                 Center for Automation Research
**                   University of Maryland
**                   College Park, MD 20742
**  $Id: ParseArgTest.c,v 1.1 2000/09/19 22:16:27 maosong Exp $
*/


#include <stdio.h>
#include <stdlib.h>

void ParseArgTest(int argc, char **argv, 
	char **test_report_p, char **test_protocol_file_p,
        char **seg_file_p, char **ben_file_p, char **weight_file_p)
{
	char		c;
	char		errflg = 0;
	extern char	*optarg;

	if(argc == 1) {
   	  	printf("Usage: TestSeg 	-p <test_protocol_file> -b <bench_param_file>
                               -s <seg_param_file> -w <weight_file> -t <TestReport>\n");
    	  	exit(1);
  	}

	*test_report_p = (char *) malloc (256 * sizeof(char));
	*test_protocol_file_p 	= (char *) malloc (256 * sizeof(char));
	*seg_file_p	= (char *) malloc (256 * sizeof(char));
	*ben_file_p 	= (char *) malloc (256 * sizeof(char));
	*weight_file_p 	= (char *) malloc (256 * sizeof(char));

	while((c = getopt(argc, argv, "p:b:s:t:w:")) != EOF)
        	switch (c) {
        		case 'p':
				sscanf(optarg, "%s", *test_protocol_file_p);
				break;
			case 'b':
				sscanf(optarg, "%s", *ben_file_p);
                                break;
                        case 's':
				sscanf(optarg, "%s", *seg_file_p);
                                break;
        		case 'w':
                		sscanf(optarg,"%s", *weight_file_p);
                		break;
        		case 't':
                		sscanf(optarg,"%s", *test_report_p);
                		break;
        		case '?':
               			errflg++;
                		break;
		}

	if(errflg !=0 || argc != 11) {
		printf("Wrong arguments!\n");
		exit(-1);
	}

}
