/* 
**  File: ParseArgTrain.c
**  Purpose: parsing the command line argument
**  Author: Song Mao (maosong@cfar.umd.edu)
**  Date:   22 March 1999
**  Organization: Language and Media Processing Lab
**                 Center for Automation Research
**                   University of Maryland
**                   College Park, MD 20742
**  $Id: ParseArgTrain.c,v 1.1 2000/09/19 22:16:27 maosong Exp $
*/


#include <stdio.h>
#include <stdlib.h>

void ParseArgTrain(int argc, char **argv, 
	char **train_report_p, char **opt_seg_param_p,
	char **train_protocol_file_p, char **opt_file_p,
	char **seg_file_p, char **ben_file_p, char **weight_file_p)
{
	char		c;
	char		errflg = 0;
	extern char	*optarg;

	if(argc == 1) {
   	  	printf("Usage: TrainSeg -p <train_protocol_file>
			-o <opt_param_file> -b <bench_param_file>
			-s <seg_param_file> -w <weight_file>
			-t <TrainReport> -r <Optimal_Seg_Parameter_file>\n");
    	  	exit(1);
  	}

	*train_report_p = (char *) malloc (256 * sizeof(char));
	*opt_seg_param_p = (char *) malloc (256 * sizeof(char));
	*train_protocol_file_p 	= (char *) malloc (256 * sizeof(char));
	*opt_file_p 	= (char *) malloc (256 * sizeof(char));
	*seg_file_p	= (char *) malloc (256 * sizeof(char));
	*ben_file_p 	= (char *) malloc (256 * sizeof(char));
	*weight_file_p 	= (char *) malloc (256 * sizeof(char));

	while((c = getopt(argc, argv, "p:o:b:s:t:w:r:")) != EOF)
        	switch (c) {
        		case 'p':
				sscanf(optarg, "%s", *train_protocol_file_p);
				break;
			case 'o':
				sscanf(optarg, "%s", *opt_file_p);
                                break;
			case 'b':
				sscanf(optarg, "%s", *ben_file_p);
                                break;
                        case 's':
				sscanf(optarg, "%s", *seg_file_p);
                                break;
        		case 't':
                		sscanf(optarg,"%s", *train_report_p);
                		break;
        		case 'w':
                		sscanf(optarg,"%s", *weight_file_p);
                		break;
        		case 'r':
                		sscanf(optarg,"%s", *opt_seg_param_p);
                		break;
        		case '?':
               			errflg++;
                		break;
		}

	if(errflg !=0 || argc != 15) {
		printf("Wrong arguments!\n");
		exit(-1);
	}

}
