/*
**  File: ReadFileNames.c
**  Purpose: read dataset list file into dataset structure
**  Author: Song Mao (maosong@cfar.umd.edu)
**  Date:   22 March 1999
**  Organization: Language and Media Processing Lab
**                 Center for Automation Research
**                   University of Maryland
**                   College Park, MD 20742
**  $Id: ReadFileNames.c,v 1.1 2000/09/19 22:16:27 maosong Exp $
*/

#include <stdio.h>
#include <stdlib.h>

#include "pset.h"

void ReadFileNames(char *datafile, DATASET **dataset_p)
{
  	FILE *fp;
	char c;
  	int  i;
	char *tmp;

	tmp = (char *) malloc (256 * sizeof(char));

  	fp = fopen(datafile, "r");
        if(fp == NULL) {
                printf("Can not open dataset file!\n");
                exit(-1);
        }

	(*dataset_p)->nImg = 0;
        while(!feof(fp)) {
                c = fgetc(fp);
                switch(c) {
                        case '#':
                                fgets(tmp,256,fp);
                                break;
                        case EOF:
                                break;
                        case ' ':
                                break;
                        case '\n':
                                break;
                        default:
				ungetc(c,fp);
				((*dataset_p)->nImg)++;
                                fgets(tmp,256,fp);
				break;
		}
	}

 	rewind(fp);
  	(*dataset_p)->ImgName = (char **) malloc ( (*dataset_p)->nImg * sizeof(char *));
  	for(i = 0; i < (*dataset_p)->nImg; i++) 
    	 	((*dataset_p)->ImgName)[i] = (char *) malloc (256 * sizeof(char));

	i = 0;
        while(!feof(fp)) {
                c = fgetc(fp);
                switch(c) {
                        case '#':
                                fgets(tmp,256,fp);
                                break;
                        case EOF:
                                break;
                        case ' ':
                                break;
                        case '\n':
                                break;
                        default:
				ungetc(c,fp);
                                fscanf(fp, "%s", (*dataset_p)->ImgName[i]);
				i++;
                                fgets(tmp,256,fp);
                                break;
                }
        }
	
	fclose(fp);
	free(tmp);
}
