/* 
**  File: ReadWeight.c
**  Purpose: read weight parameters
**  Author: Song Mao (maosong@cfar.umd.edu)
**  Date:   29 June 2000
**  Organization: Language and Media Processing Lab
**                 Center for Automation Research
**                   University of Maryland
**                   College Park, MD 20742
**  $Id: ReadWeight.c,v 1.1 2000/09/19 22:16:27 maosong Exp $
*/

#include <stdio.h>
#include <stdlib.h>

#include "pset.h"

void ReadWeight(char *weight_file, WEIGHT **weight_p)
{
        FILE *fp;
        char c;
        char *item, *tmp, *itemVal;

        item = (char *) malloc (256 * sizeof(char));
        tmp = (char *) malloc (256 * sizeof(char));
        itemVal = (char *) malloc (256 * sizeof(char));

	((WEIGHT *)(*weight_p)) = (WEIGHT *) malloc (sizeof(WEIGHT));

        fp = fopen(weight_file, "r");
        if(fp == NULL) {
                printf("Can not open weight file!\n");
                exit(-1);
        }

        while(!feof(fp)) {
                c = fgetc(fp);
                switch(c) {
                        case '#':
                                fgets(tmp,256,fp);
                                break;
                        case EOF:
                                break;
                        case ' ':
                                break;
                        case '\t':
                                break;
                        case '\n':
                                break;
                        default:
				ungetc(c,fp);
                                fscanf(fp, "%s%s%s", item, tmp, itemVal);
                                if(strcmp(item, "wSpl") == 0) {
				  if(atof(itemVal) < 0) {
                                    printf("Invalid wSpl weight parameter value.\n");
                                    exit(-1);
                                  }
                                  else 
                                    ((WEIGHT *)(*weight_p))->wSpl = atof(itemVal);
                                }
				else if(strcmp(item, "wMrg") == 0) {
				  if(atof(itemVal) < 0) {
                                    printf("Invalid wMrg weight parameter value.\n");
                                    exit(-1);
                                  }
                                  else 
                                    ((WEIGHT *)(*weight_p))->wMrg = atof(itemVal);
				}
				else if(strcmp(item, "wMis") == 0) {
                                  if(atof(itemVal) < 0) {    
                                    printf("Invalid wMis weight parameter value.\n");
                                    exit(-1);  
                                  }    
                                  else 
                                    ((WEIGHT *)(*weight_p))->wMis = atof(itemVal);
				}
				else if(strcmp(item, "wFA") == 0) {
                                  if(atof(itemVal) < 0) {    
                                    printf("Invalid wFA weight parameter value.\n");
                                    exit(-1);  
                                  }    
                                  else 
                                    ((WEIGHT *)(*weight_p))->wFA = atof(itemVal);
				}
				else if(strcmp(item, "wSplLine") == 0) {
                                  if(atof(itemVal) < 0) {    
                                    printf("Invalid wSplLine weight parameter value.\n");
                                    exit(-1);  
                                  }    
                                  else 
                                    ((WEIGHT *)(*weight_p))->wSplLine = atof(itemVal);
				}
				else if(strcmp(item, "wMrgLine") == 0) {
                                  if(atof(itemVal) < 0) {    
                                    printf("Invalid wMrgLine weight parameter value.\n");
                                    exit(-1);  
                                  }    
                                  else 
                                    ((WEIGHT *)(*weight_p))->wMrgLine = atof(itemVal);
				}
				else if(strcmp(item, "wMisLine") == 0) {
                                  if(atof(itemVal) < 0) {    
                                    printf("Invalid wMisLine weight parameter value.\n");
                                    exit(-1);  
                                  }    
                                  else 
                                    ((WEIGHT *)(*weight_p))->wMisLine = atof(itemVal);
				}
				else if(strcmp(item, "wFAZone") == 0) {
                                  if(atof(itemVal) < 0) {    
                                    printf("Invalid wFAZone weight parameter value.\n");
                                    exit(-1);  
                                  }    
                                  else 
                                    ((WEIGHT *)(*weight_p))->wFAZone = atof(itemVal);
				}
				else {
                                  printf("Invalid weight parameter name.\n");
				  exit(-1);
				}
				break;
		}
	}
	fclose(fp);
	free(item);
	free(tmp);
	free(itemVal);
}
