/*
**  File: Test.c
**  Purpose: points to the objective function to be optimized
**	     and call the optimization algorithm
**  Author: Song Mao (maosong@cfar.umd.edu)
**  Date:   22 March 1999
**  Organization: Language and Media Processing Lab
**                 Center for Automation Research
**                   University of Maryland
**                   College Park, MD 20742
**  $Id: Test.c,v 1.1 2000/09/19 22:16:27 maosong Exp $
*/

#include <stdio.h>
#include <stdlib.h>

#include "pset.h"

void Test(TEST_PROTOCOL *test_protocol, void *ben_param,
	  void *seg_param, char *weight_file, char **test_report_p)
{
        switch (test_protocol->seg_alg) {
                case XYCUT:
                        EvalXycut(test_protocol, seg_param, ben_param,
				  weight_file, test_report_p);    /* evaluate X-Y cut algorithm */
                        break;
                case DOCSTRUM:
                        EvalDocstrum(test_protocol, seg_param, ben_param,
				     weight_file, test_report_p); /* evaluate Docstrum algorithm */
                        break;
                case VORONOI:
                        EvalVoronoi(test_protocol, seg_param, ben_param,
				    weight_file, test_report_p); /* evaluate Voronoi algorithm */
                        break;
                default:
			printf("No such segmentation algorithm.\n");
                        break;
        }
}
