/* static char version_string[]="$Id: VoronoiFunction.c,v 1.1 2000/09/19 22:16:27 maosong Exp $"; */
/*
   $Date: 2000/09/19 22:16:27 $
   $Revision: 1.1 $
   $Author: maosong $
   main.c
   ᥤץ
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Song's modification*/
#include <unistd.h>
#include <fcntl.h>

#include "rafport.h"
#include <sys/types.h>
#include <sys/uio.h>
#include "dafstype.h"
#include "rlimage.h"
#include "dafs.h"

#include "tiffio.h"
#include "tiff.h"

#include "pset.h"

/* end-of-modification */

BlackPixel 	*bpx;		/* ǤκɸȤΥ٥ 
				   coordinates and a label of a black pixel */
Neighborhood	*neighbor;	/* Ϣʬ֤ħ
				   features between CC's */
LineSegment	*lineseg;	/* κɸȥ٥
				   coordinates of line segments*/
HashTable	*hashtable[M1+M2];
                                /* ϢʬΥ٥Фϥåɽ
				   the hash table for labels of CC's */
EndPoint	*endp;		/* ʬü
				   Endpoints of line segments */
NumPixel	BPnbr;		/* Ǥο
				   # of black pixels */
Label	        LABELnbr;	/* Ϣʬ
				   # of CC's */
unsigned int	NEIGHnbr;	/* ܤϢʬȤο
				   # of pairs of neighboring CC's */
unsigned int	LINEnbr;	/* ΥꥢܥΥդ
				   ʬο
				   # of line segments in the area Voronoi
				   diagram before deletion */
unsigned int	Enbr;		/* ܥΥդϢ
				   ʬȤο
				   # of pairs of CCs whose Voronoi edges
				   are deleted */
long		SiteMax;	/* ܥΥֹκ
				   max. # of Voronoi points */

int		noise_max = NOISE_MAX;	   /* Ϣʬβǿ */
int		sample_rate = SAMPLE_RATE; /* פǥץ󥰤 */
					   /*  */
float		freq_rate = FREQ_RATE;
int             Ta = Ta_CONST;
unsigned int	sample_pix;	/* ץ󥰤줿ǿ
				   # of sampled pixels */
unsigned int	point_edge;	/* ܥΥդܿ
				   # of Voronoi edges in the point
				   Voronoi diagram */
unsigned int	edge_nbr;	/* ΥꥢܥΥդʬܿ
				   # of line segments after deletion */
int             *area;          /* ٥ln ΤĤϢʬ
				   the area of a CC whose label is ln */

#ifdef TIME
float    b_s_time=0;
float    v_time=0;
float    e_time=0;
float    o_time=0;
#endif /* TIME */

float	xmin, xmax, ymin, ymax, deltax, deltay;

struct	Site		*sites;
int			nsites;
int			siteidx;
int			sqrt_nsites;
int			nvertices;
struct 	Freelist 	sfl;
struct	Site		*bottomsite;

int 			nedges;
struct	Freelist 	efl;

struct  Freelist	hfl;
struct	Halfedge	*ELleftend, *ELrightend;
int 			ELhashsize;
struct	Halfedge	**ELhash;

int 			PQhashsize;
struct	Halfedge 	*PQhash;
int 			PQcount;
int 			PQmin;

/* the size of a smoothing window*/
int    smwind = SMWIND;

/* ɲʬ */
char     output_pvor = NO;
char     output_avor = NO;
char     display_parameters = NO;

#ifdef RECT
/* definition of connected components */
int      crect_width_max  = CRECT_WIDTH_MAX;
int      crect_height_max = CRECT_HEIGHT_MAX;
/* int      crect_area_max   = CRECT_AREA_MAX; */
float    crect_aspect_max = CRECT_ASPECT_MAX;

/* definition of valid blocks */
float    brect_aspect_max = BRECT_ASPECT_MAX;
float    brect_varea_min = BRECT_VAREA_MIN;
float    brect_area_min = BRECT_AREA_MIN;

Rect     *crect; /* bounding boxes of connected components */
Rect     *brect; /* bounding boxes of segmented blocks */
Label    *cb_tab; /* connected component to segmented block table
		     cb_table[label]=block_id */
Label    BRECTid = 0; /* id. of segmented blocks */
Label    BRECTnbr = 0; /* no. of segmented blocks */
#endif /* RECT */

/* Song's mod */
/* edgelist.c */
extern int ntry, totalsearch;

/* erase.c */
extern float Td2;
extern unsigned int Td1;
extern unsigned int Dmax;

/* label_func.c */
extern Coordinate imax, jmax;

/* memory.c */
extern unsigned int total_alloc;
/* Song's mod */

void VoronoiFunction(char *tif_filename, VORONOI_PARAM *para, char *dafs_filename) 
{
    /* FILE		*ofp; */
    int 		i;
    /* int                 ifargc, ofargc; */
    ImageData		imgd1;

    /* Song's modification */ 
    TIFF *tif;

    iEntityPtr dafs_doc;
    iEntityPtr dafs_zone;
    /* iEntityPtr dafs_line; */
    iDAFSError dafs_error;
    iBox dafs_box;
    iImagePtr imPtr;

    float floattag;
    int xres, yres;

    int j;
    HashTable **free_hash;
    HashTable *tmp_hash;
    int       free_hash_index = 0;

    EndPoint **free_endp;
    EndPoint *tmp_endp;
    int      free_endp_index = 0;
    /* end-of-Song's modification */

#ifdef TIME
    clock_t		start, end;
#endif

    point_edge = 0;
    edge_nbr = 0;

    BPnbr = LABELnbr = NEIGHnbr = LINEnbr = Enbr = SiteMax = 0;

    /* analysis of arguments 
    analyze_cline(argv,&ifargc,&ofargc);
    */

    tif = TIFFOpen(tif_filename, "r");
    if (tif == NULL) {
      printf("Can not open image file.\n");
      exit(-1);
    }
    floattag = 0;
    TIFFGetField(tif, TIFFTAG_XRESOLUTION, &floattag);
    xres = (int) floattag;

    floattag = 0;
    TIFFGetField(tif, TIFFTAG_YRESOLUTION, &floattag);
    yres = (int) floattag;
    TIFFClose(tif);

    /* Song's modification */
    sample_rate = para->sr;
    noise_max = para->nm * xres / 300;
    freq_rate = para->fr;
    Ta = para->ta;
    smwind = para->sw;
    display_parameters = NO;
    /* end-of-Song's modification */

    /* ե륪ץ
       opening the output file */
    /*
    if((ofp = fopen(argv[ofargc],"w"))==NULL) {
	fprintf(stderr,"can't open output-file\n");
	exit(1);
    }
    */

    /* reading the image data */
    /* read_image(argv[ifargc],&imgd1); */

    /* Song's modification */
    read_image(tif_filename, &imgd1);
    /* en-of-Song's modification */

    /* ѥ᡼ɽ
       displaying parameters */
    if(display_parameters == YES)
      dparam();

    /* μ1 ʬ0 ˥åȤ. */
    frame(&imgd1,1,0);

    /* bpx ΰ */
    bpx=(BlackPixel *)myalloc(sizeof(BlackPixel)* INITPIXEL);

    /* Site sites ΰ */
    sites = (struct Site *) myalloc(SITE_BOX*sizeof *sites);

#ifdef RECT
    init_crect();
#endif
    
    /* ϲSite Ѵ */
    /* fprintf(stderr,"Transforming Image to Site..."); */
#ifdef TIME
    start = clock();
#endif
    img_to_site(&imgd1);
#ifdef TIME
    end = clock();
    b_s_time = (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif
    /* fprintf(stderr,"done\n"); */

    /* area[ln] ΰ */
    area=(int *)myalloc(sizeof(int)*LABELnbr);

    /* area[ln] ͤ
       initialization */
    for(i=0;i<LABELnbr;i++) area[i]=0;

    /* area[ln] ͤ򥻥å
       setting values */
    for(i=0;i<BPnbr;i++) area[bpx[i].label]++;

    /* bpx ΰ */

    free(bpx);
    
    /* Ϣʬ֤ħneighbor ΰ */
    neighbor = (Neighborhood *)myalloc(sizeof(Neighborhood)* INITNEIGHBOR);

    /* ʬlineseg ΰ */
    lineseg = (LineSegment *)myalloc(sizeof(LineSegment)* INITLINE);

    /* ϥåɽ
       initialization of hash tables */
    init_hash();

    /* ꥢVoronoi ޺ 
       constructing the area Voronoi diagram */
    
    /* fprintf(stderr,"Constructing area Voronoi diagram..."); */
#ifdef TIME
    start = clock();
#endif
    voronoi(imgd1.imax, imgd1.jmax);
#ifdef TIME
    end = clock();
    v_time = (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif
    /* fprintf(stderr,"done\n"); */

    /* ܥΥդüendp ΰ
       malloc for endp --- end points of line segments */
    SiteMax+=1;
    endp = (EndPoint *)myalloc(sizeof(EndPoint) * SiteMax);
    
    /* Deletion of superfluous Voronoi edges */
    /* fprintf(stderr,"Deleting superfluous Voronoi edges..."); */
#ifdef TIME
    start = clock();
#endif
    erase();
#ifdef TIME
    end = clock();
    e_time = (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif
    /* fprintf(stderr,"done\n"); */

    /* neighbor ΰ */

    free(neighbor);

#ifdef RECT
    generate_brect();
#endif /* RECT */
        
    /* OUTPUT */
#ifdef TIME
    start = clock();
#endif
#ifdef RECT

    /* Song's modification */
    dafs_error = i_InitLib();
    dafs_doc = i_NewEntity(iDocumentT, 0);
    dafs_box.x = 0;
    dafs_box.y = 0;
    dafs_box.w = imgd1.imax;
    dafs_box.h = imgd1.jmax;
    i_SetBox(dafs_doc,dafs_box);    
    /* end-of-modification */

    for(i=0;i<BRECTid;i++){
      if(brect[i].xs!=NORECT && is_noise_brect(brect[i])==NO){

        /* Song's modification */
        dafs_zone = i_NewEntity(iParagraphT, dafs_doc);
        dafs_box.x = brect[i].xs;
        dafs_box.y = brect[i].ys;
        dafs_box.w = brect[i].xe - brect[i].xs + 1;
        dafs_box.h = brect[i].ye - brect[i].ys + 1;
        i_SetBox(dafs_zone, dafs_box);
        /* end-of-Song's modification */


        /*
	fprintf(ofp,"%d %d %d %d\n",
	 	brect[i].xs,brect[i].xe,
		brect[i].ys,brect[i].ye);
        */

	BRECTnbr++;
      }
    }

    /* Song's modification */
    dafs_error = i_ReadImage(tif_filename, &imPtr);
    i_SetImage(dafs_doc, imPtr);
    dafs_error=i_WriteEntity(dafs_filename, dafs_doc, DAFSB);
    i_DisposeImage(imPtr);
    i_DisposeEntity(dafs_doc);
    i_ExitLib();
    /* end-of-Song's modification */

    /* for debug --- output is bounding boxes of connected components */
    /*
    for(i=0;i<LABELnbr;i++){
      if(crect[i].xs!=NORECT){
	fprintf(ofp,"%d %d %d %d\n",
		crect[i].xs,crect[i].xe,
		crect[i].ys,crect[i].ye);
	}
    }
    */

#endif /* RECT */
    for(i=0;i<LINEnbr;i++) {
	if(lineseg[i].yn == OUTPUT &&
	   (lineseg[i].xs != lineseg[i].xe
	    || lineseg[i].ys != lineseg[i].ye)) {
#ifndef RECT	  
	    /* fprintf(ofp,"%d %d %d %d\n",
		    lineseg[i].xs,lineseg[i].xe,
		    lineseg[i].ys,lineseg[i].ye);
	    */
#endif /* RECT */
	    edge_nbr++;
	}
    }

#ifdef TIME
    end = clock();
    o_time = (float)((end-start)/((float)CLOCKS_PER_SEC));
#endif
    /* ե륯 */
    /* fclose(ofp); */

    dnumber(imgd1.imax, imgd1.jmax);
    /* ΰ */

    free(area);
    free(sites);
    free(lineseg);

    /* Song's code */
    for(i=0; i<SiteMax; i++) {
      tmp_endp = endp[i].next;
      while(tmp_endp != NIL) {
        free_endp_index++;
        tmp_endp = tmp_endp->next;
      }
      free_endp = (EndPoint **) malloc ((free_endp_index + 1) * sizeof(EndPoint *));
      tmp_endp = endp[i].next;
      free_endp_index = 0;
      while(tmp_endp != NIL) {
        free_endp[free_endp_index++] = tmp_endp;
        tmp_endp = tmp_endp->next;
      }

      for(j=0; j<free_endp_index; j++)
        free(free_endp[j]);
      free(free_endp);
    }
  /* end of Song's code */

    free(endp);
    free(imgd1.image);

#ifdef RECT
    free(crect);
    free(brect);
    free(cb_tab);
#endif /* RECT */

/* Song's code */
free(ELhash);
free_limg();
free(PQhash);
/* end of Song's code */

#ifdef TIME
    dtime();
#endif

/* Clean up global variables */
	BPnbr=0;		/* Ǥο
				   # of black pixels */
	        LABELnbr=0;	/* Ϣʬ
				   # of CC's */
	NEIGHnbr=0;	/* ܤϢʬȤο
			   # of pairs of neighboring CC's */
	LINEnbr=0;	/* ΥꥢܥΥդ
				   ʬο
				   # of line segments in the area Voronoi
				   diagram before deletion */
	Enbr=0;		/* ܥΥդϢ
				   ʬȤο
				   # of pairs of CCs whose Voronoi edges
				   are deleted */
		SiteMax=0;	/* ܥΥֹκ
				   max. # of Voronoi points */

		noise_max = NOISE_MAX;	   /* Ϣʬβǿ */
		sample_rate = SAMPLE_RATE; /* פǥץ󥰤 */
					   /*  */
	freq_rate = FREQ_RATE;
             Ta = Ta_CONST;
	sample_pix=0;	/* ץ󥰤줿ǿ
				   # of sampled pixels */
	point_edge=0;	/* ܥΥդܿ
				   # of Voronoi edges in the point
				   Voronoi diagram */
	edge_nbr=0;	/* ΥꥢܥΥդʬܿ
				   # of line segments after deletion */
            /*  *area; */          /* ٥ln ΤĤϢʬ
				   the area of a CC whose label is ln */

#ifdef TIME
    b_s_time=0;
    v_time=0;
    e_time=0;
    o_time=0;
#endif /* TIME */

			nsites=0;
			siteidx=0;
			sqrt_nsites=0;
			nvertices=0;

 			nedges=0;
 			ELhashsize=0;

 			PQhashsize=0;
 			PQcount=0;
 			PQmin=0;

/* the size of a smoothing window*/
    smwind = SMWIND;

/* ɲʬ */
     output_pvor = NO;
     output_avor = NO;
     display_parameters = NO;

#ifdef RECT
/* definition of connected components */
crect_width_max  = CRECT_WIDTH_MAX;
crect_height_max = CRECT_HEIGHT_MAX;
/* int      crect_area_max   = CRECT_AREA_MAX; */
crect_aspect_max = CRECT_ASPECT_MAX;

/* definition of valid blocks */
brect_aspect_max = BRECT_ASPECT_MAX;
brect_varea_min = BRECT_VAREA_MIN;
brect_area_min = BRECT_AREA_MIN;

BRECTid = 0; /* id. of segmented blocks */
BRECTnbr = 0; /* no. of segmented blocks */
#endif /* RECT */

/* edgelist.c */ 
ntry =0;
totalsearch = 0;

/* erase.c */ 
Td2 = 0.0;
Td1 = 0;
Dmax = 0;

/* label_func.c */ 
imax = 0;
jmax = 0;

/* memory.c  */
total_alloc = 0;

/* free hashtable */
for(i=0;i<M1+M2; i++) {
  tmp_hash = hashtable[i];
  while(tmp_hash != NIL) {
    free_hash_index++;
    tmp_hash = tmp_hash->next;
  }
  free_hash = (HashTable **) malloc ((free_hash_index + 1) * sizeof(HashTable *));
 
  tmp_hash = hashtable[i];
  free_hash_index = 0;
  while(tmp_hash != NIL) {
    free_hash[free_hash_index++] = tmp_hash;
    tmp_hash = tmp_hash->next;
  }

  for(j=0; j<free_hash_index; j++)
    free(free_hash[j]);
  free(free_hash);

}

/* end of clean up global variables */

}
