/* static char version_string[]="$Id: memory.c,v 1.1 2000/09/19 22:16:27 maosong Exp $"; */
/*
   $Date: 2000/09/19 22:16:27 $
   $Revision: 1.1 $
   $Author: maosong $
   memory.c
*/

#include <stdio.h>
#include <stdlib.h>

#include "pset.h"

unsigned int total_alloc = 0;

void freeinit(struct Freelist *fl, int size)
{
  fl -> head = (struct Freenode *) NULL;
  fl -> nodesize = size;
}

char *getfree(struct Freelist *fl)
{
  int i; struct Freenode *t; /* *tt; */
  if(fl->head == (struct Freenode *) NULL) {
    t =  (struct Freenode *) myalloc(sqrt_nsites * fl->nodesize);
    for(i=0; i<sqrt_nsites; i+=1) 	
      makefree((struct Freenode *)((char *)t+i*fl->nodesize), fl);
  }

  t = fl -> head;
  fl -> head = (fl -> head) -> nextfree;
  return((char *)t);
}

void makefree(struct Freenode *curr, struct Freelist *fl)
{
  curr -> nextfree = fl -> head;
  fl -> head = curr;
}

char *myalloc(unsigned n)
{
  char *t;
  if ((t=malloc((size_t) n)) == (char *) 0) {
    fprintf(stderr,
	    "Insufficient memory (%d bytes in use)\n",
	    total_alloc);
    exit(0);
  }
  total_alloc += n;

  return(t);
}

char *myrealloc(void *ptr, unsigned current, unsigned inc, size_t unit)
{
  char *t;
  if ((t=realloc(ptr,(current+inc)*unit)) == (char *) 0) {
    fprintf(stderr,
	    "Insufficient memory (%d bytes in use)\n",
	    total_alloc);
    exit(0);
  }
  total_alloc += inc;
 
  return(t);
}
