/* static char version_string[]="$Id: voronoi.c,v 1.1 2000/09/19 22:16:27 maosong Exp $"; */
/*
   $Date: 2000/09/19 22:16:27 $
   $Revision: 1.1 $
   $Author: maosong $
   voronoi.c
*/

#include <stdio.h>

#include "pset.h"

/* implicit parameters: nsites, sqrt_nsites, xmin, xmax, ymin, ymax,
   deltax, deltay (can all be estimates).
   Performance suffers if they are wrong; better to make nsites,
   deltax, and deltay too big than too small.  (?) */

void voronoi( Coordinate imax, Coordinate jmax)
{
  struct Site *newsite, *bot, *top, *temp, *p;
  //struct Site *v;
  /* Song's mod { */
  struct Site *v = NULL;
  /* Song's mod } */
  struct Point newintstar;
  int pm;
  struct Halfedge *lbnd, *rbnd, *llbnd, *rrbnd, *bisector;
  struct Edge *e;

  /* Song's 
  unsigned int free_i = 0;
  unsigned int i;
  struct Halfedge **free_bi;
  
  free_bi = (struct Halfedge **) malloc (500000 * sizeof(struct Halfedge *) );
  end of Song's */

  freeinit(&sfl, sizeof *sites);
  siteidx = 0;
  geominit();
  PQinitialize();
  bottomsite = (*nextsite)();
  ELinitialize();

  newsite = (*nextsite)();

  while(1) {
    if(!PQempty()) newintstar = PQ_min();

    if (newsite != (struct Site *)NULL 
	&& (PQempty() 
	    || newsite -> coord.y < newintstar.y
	    || (newsite->coord.y == newintstar.y 
		&& newsite->coord.x < newintstar.x))) {
      /* new site is smallest */
      lbnd = ELleftbnd(&(newsite->coord));
      rbnd = ELright(lbnd);
      bot = rightreg(lbnd);
      e = bisect(bot, newsite);
      bisector = HEcreate(e, LE);
  
      /* Song's mod 
      free_bi[free_i++]=bisector;
      end of Song's mod */

      ELinsert(lbnd, bisector);
      if ((p = intersect(lbnd, bisector)) != (struct Site *) NULL) {
	PQdelete(lbnd);
	PQinsert(lbnd, p, dist(p,newsite));
      }
      lbnd = bisector;
      bisector = HEcreate(e, RE);

      /* Song's mod 
      free_bi[free_i++]=bisector;
      end of Song's mod */

      ELinsert(lbnd, bisector);
      if ((p = intersect(bisector, rbnd)) != (struct Site *) NULL) {
	PQinsert(bisector, p, dist(p,newsite));	
      }
      newsite = (*nextsite)();	
    }
    else if (!PQempty()) {
      /* intersection is smallest */
      lbnd = PQextractmin();
      llbnd = ELleft(lbnd);
      rbnd = ELright(lbnd);
      rrbnd = ELright(rbnd);
      bot = leftreg(lbnd);
      top = rightreg(rbnd);
	    
      v = lbnd->vertex;
      makevertex(v);
      endpoint(lbnd->ELedge,lbnd->ELpm,v,imax,jmax);
      endpoint(rbnd->ELedge,rbnd->ELpm,v,imax,jmax);
      ELdelete(lbnd); 
      PQdelete(rbnd);
      ELdelete(rbnd); 
      pm = LE;
      if (bot->coord.y > top->coord.y) {
	temp = bot;
	bot = top;
	top = temp;
	pm = RE;
      }
      e = bisect(bot, top);
      bisector = HEcreate(e, pm);

      /* Song's mod
      free_bi[free_i++]=bisector;
      end of Song's mod */

      ELinsert(llbnd, bisector);
      endpoint(e, RE-pm, v, imax, jmax);
      deref(v);
      if((p = intersect(llbnd, bisector)) != (struct Site *) NULL){
	PQdelete(llbnd);
	PQinsert(llbnd, p, dist(p,bot));
      }
      if ((p = intersect(bisector, rrbnd)) != (struct Site *) NULL){
	PQinsert(bisector, p, dist(p,bot));
      }
    }
    else break;
  }

  for(lbnd=ELright(ELleftend); lbnd != ELrightend; lbnd=ELright(lbnd)) {
    e = lbnd -> ELedge;
    out_ep2(e,v,imax,jmax); /* Voronoi դ */
  }

  /* Song's mod 
  printf("\nfree_i = %d\n",free_i);
  if(free_i > 0) {
     for(i = 0; i<free_i-5; i++)
       if(free_bi[i] != NIL)
         free(free_bi[i]);
  }
  free(free_bi);
  free_bi = 0;
  end of Song's mod */

}
